#include "utils.PRO2"

// Nombres de Fibonacci
//fib(0) = 1
//fib(1) = 1 
//fib(n) = fib(n-1) + fib(n-2) si n>1

//Pre: n>=0
int fib(int n) {
  if (n<=1) return 1;  
  else  return fib(n-1)+fib(n-2);
}
//Post retorna el nombre de Fibonacci d'ordre n


//Pre: n>=0
pair<int,int> efib(int n) {
  if (n==0) return make_pair(1,1);  
  else{
    pair<int,int> fn= efib(n-1);
    //HI: fn.first = Fibonacci n-1 i fn.second = Fibonacci n 
    return make_pair(fn.second, fn.first + fn.second);
  }
}
//Post retorna parell amb el nombre de Fibonacci d'ordre n i n+1


/* Justificació:


0) Crida inicial (veure main):
   (si hem afegit paràmetres o resultas cal comprovar que la crida és bona)
   
   effib(n,0).first 


1) Cas simple:
   Com n=0, tornem el parell (1,1) ja que Fibonacci(0) és 1 i 
   Fibonacci(1) és 1

2) Cas recursiu:
   La crida és correcta ja que com n!=0, tenim que n>0 i per tant
   n-1>=0.  Per induccio fn.first = Fibonacci n-1 i fn.second =
   Fibonacci(n), i, per tant, fn.first + fn.second = Fibonacci(n+1)

4) Acabament: 
   Decreix la n.

*/



//Pre: n>=i>=0; f1 = Fibonacci i; f2 = Fibonacci i+1;
int ffib(int n, int i, int f1, int f2) {
  if (i==n) return f1;  
  else return ffib(n, i+1, f2, f1+f2);
}
//Post retorna el nombre de Fibonacci d'ordre n


/* Justificació:


0) Crida inicial (veure main):
   (si hem afegit paràmetres o resultas cal comprovar que la crida és bona)
   
   ffib(n,0,1,1) 

   Satisfà la precondició, ja que el Fibonacci de 0 és 1 i el de 1 és 1.
   Com que n>=0, tenim que n>=0>=0

1) Cas simple:
   Com i=n, per la precondició tenim que f1 = Fibonacci(n)

2) Cas recursiu:
   Comprovem que la crida satisfà la precondició, és a dir usant Pre,
   hem de demostrar que la crida satisfà Pre substituint els
   parametres i, f1, f2 per la crida real i+1, f2, f1+f2.
   Per tant, cal demostrar que 
       n>=i+1>=0, f2 = Fibonacci i+1, f1+f2 = Fibonacci i+2;
   El primer surt de que n>=i>=0 (Pre) i que i!=n (else).
   El segon i el tercer surten de la Pre i la definició de Fibonacci.   

   Com que la crida és bona, per inducció tenim que retorna el
   Fibonacci d'ordre n, i per tant hem acabat.

4) Acabament: 
   Decreix la distància entre la n i la i, és a dir n-i>=0.

*/


//Pre: n>=0
int ifib(int n) {
  int i=0;
  int f1=1;
  int f2=1;
  //Inv: n>=i>=0; f1 = Fibonacci(i); f2 = Fibonacci(i+1);
  while ( i<n ) {
    int f=f1+f2;
    f1=f2;
    f2=f;
    ++i;
  }
  //Postw: f1 =  Fibonacci(n)
  return f1;
}
//Post retorna el nombre de Fibonacci d'ordre n

/* Justificació:

1) Inicialitzacions: 
   El Fibonacci de 0 és 1 i el de 1 és 1.
   Com que n>=0, tenim que n>=i>=0

2) Cos del bucle:
   Com que volem incrementar la i, necessitem que f1= Fibonacci(i+1) i 
   f1= Fibonacci(i+2), per tant per l'invariant f1 ha de pendre el valor 
   de f2 i f2 la suma dels valors de f1 i f2. Al incrementar la i es torna 
   a satisfer l'invariant.

3) Condició de sortida:
   Com que i<=n, quan sortim tenim i=n, llavors, com que per l'invariant 
   f1 = Fibonacci(i), tenim que f1 = Fibonacci(n)

4) Acabament: 
   Decreix la distància entre la n i la i, és a dir n-i>=0.
   A cada volta decreix n-i ja que incrementem i. 

*/

//Pre: n>=0
int fibP1(int n) {
// Pre: n >= 0
int f1 = 1;
int f2 = 1;
int i = 1;
// Inv: f1 is the Fibonacci number of order i.
while (i < n) {
int f = f1 + f2;
f2 = f1;
f1 = f;
i = i + 1;
}
return f1;
}
// Post: Returns the Fibonacci number of order n.


int main() {
  int n;
  cin >> n;
  
  cout << efib(n).first << endl;
  cout << ffib(n,0,1,1) << endl;
  cout << ifib(n) << endl;
  cout << fibP1(n) << endl;
  cout << fib(n) << endl;

}
