#include "utils.PRO2"
#include "Arbre.hpp"

/* Pre: a=A , b = B */
bool iguals(Arbre<int> &a, Arbre<int> &b){
  bool ig;
  if (a.es_buit() and b.es_buit()) ig=true;
  else if (a.es_buit() or b.es_buit()) ig= false;
  else {
    if (a.arrel() != b.arrel()) ig= false;
    else{
      Arbre<int> a1;
      Arbre<int> a2;
      a.fills(a1,a2);
      Arbre<int> b1;
      Arbre<int> b2;
      b.fills(b1,b2); 
      if (not iguals(a1,b1)) 
	//HI1a: el fill esquerra d'A i el de B no són iguals
        ig= false;
      else //HI1b: el fill esquerra d'A i el de B són iguals
        ig= iguals(a2,b2);
        //HI2: ig = "el fill dret d'A i el de B són iguals"
    }
  }
// Post1: ig = "A i B són iguals"

  return ig;
}
// Post: retorna si A i B són iguals o no


/* Justificació 

1) Casos senzills.

   a)Si A i B són buits llavors són iguals.

   b)Si A o B no són buits i un dels dos és buit llavors és que un es
   buit i l'altre no, i per tant no són iguals.

   c) Si A i B no són buits i les arrels són diferents llavors no són
   iguals.

2) Cas resursiu.

Els arbres no són buits i les arrels són iguals.

Les crides són correctes. Com que A i B no són buits, el dos tenen
fill esquerra i fill dret. Per inducció (HI1a), tenim que els fills
esquerres no són iguals i, per tant A i B no són iguals. En cas
contrari, per (HI1b) tenim que els fills esquerres són iguals. Com que
les arrels són iguals A i B són iguals si i només si són iguals els
fills drets d'A i B, que, per inducció (HI2) és el que obtenim amb la
segona crida recursiva.

3) Acabament.

Decreix la mida d'a, ja que tant a1 com a2 tenen com a mínim un node
menys.


 */
